Subject: RE: [seamoby] IETF Architecture Work (RANT)

From: Kulwinder Atwal <[email-masked]>
Date: Fri, 13 Apr 2001 02:03:19 -0400

> -----Original Message-----
> From: Arthur Ross [mailto:[email-masked]]
> Sent: Thursday, April 12, 2001 1:37 PM
> To: Phil Neumiller; James Kempf; [email-masked]
> Cc: [email-masked]
> Subject: Re: [seamoby] IETF Architecture Work (RANT)
> 
> 
> I have long thought that the real, underlying endpoint 
> entities are neither
> "handsets" nor "hosts", but something that more nearly 
> resembles a record
> in a distributed database. The physical embodiment of it 
> could take many
> forms, but the essential abstraction would be the CONTENT, 
> not the physical
> realization. It would be logically separate from the embodiment of any
> communication device. The association of the two would occur 
> as a result of
> network interactions (the SIM/UIM is a step in this 
> direction). A variety
> of information could reside in this identity record. Addressing would
> resemble a distributed database query rather than a 
> wireless-like wide-area
> page. While this is, in the context of the current internet, 
> a sort of "DNS
> on steroids" concept, it should be quite easily doable, given 
> the current
> state-of-the-art in storage technology.
> 
> Seems to me that the endpoint of the communication should be 
> this "identity
> record", which, hopefully, could be plugged into, or 
> associated somehow,
> with whatever network access point is conventient - a 
> wireLINE terminal, a
> wireLESS terminal, a mobile subnet such as in an airplane or 
> ship, etc. The
> network would, by some means, update the routing as that 
> endpoint record
> thingy moves its attachment point. The record is a network 
> proxy for the
> real source/sink of the communication, be it a particular 
> human, the human
> in a particular business role, or some mechanical entity, such as a
> business' database.
> 
> I see this kind of thing as the ultimate evolution of ALL 
> public telecom
> ... somehow. I once heard the fixed telephone network described as a
> "special case of a mobile network with very low mobility." 
> Right on bro.
> 
> <RANT TO BE CONTINUED ... >
> 
>    -- Regards,
>    -- A
> 
> PS: Recommended reading, for those of you who missed it in 
> the original:
> 
> "Extraordinary Popular Delusions and the Madness of Crowds," 
> by Charles
> Mackay, originally published in 1841 London. While his 
> central topic is a
> series of investment manias that ran through Europe in the 
> 18th century,
> alchemy, and the vogue for witch burning in the 16th & 17th 
> century Europe,
> the human behaviors are VERY CLEARLY RECOGNIZABLE in recent 
> events, both
> financial and telecom. It's available in a Barnes & Noble 
> paperback reprint.
> 

I see that someone other than myself really gets it.  
What we need to be working toward in the IETF is a: 

Mobile Real-Time Peer-To-Peer Globally Distributed Database 

With parts of the Freenet concept:

http://news.cnet.com/news/0-1005-200-5578112.html

Where we let the L2 deal with physical entities like Physical links: 

L3 Logical Link Layer (Triggers).
L2 Physical Link Layer. (Physical Events)
L1 Physical.

Starting at the bottom, the first thing we need to get away from is routing
and context transfer protocols for L3 and above that rely on timers.  Timers
are physical embodiments.  

For routing protocols to be based on timers in a mobile environment has no
value.  

In the static internet is has been easy to pick a optimal frequency becuase
we have had only ONE Usage Model: 

Static Internet Usage Model: Stationary Computer to Stationary Computer.

And with cellular we have been adding only one more usage model.

Cellular Usage Model: Mobile Phone to Cell Tower.

But, it is impossible to predict the optimal frequency that route updates
should occur.  A user, or vehicle may remain stationary for hours at a time
then move at a high rate.  Should the router update occur once per 30
seconds, per hour, or per millisecond?  What about Context Transfer?  

Is the endpoint record a fridge, ID Badge, stereo, person, car, ship or
plane?

This is why context transfer and route updates need to occur based on
Physical Events propagated up the stack as Logical Triggers.  NOT TIMERS.
Becuase it is impossible to predict the Usage Model.

The mapping of Physical Events to Logical Triggers may change depending on
the technology, application, external event, or user preference.

We need enable all current and future Usage Models.

The Mobile Real-Time Peer-To-Peer Globally Distributed Database. 

-Kulwinder.

---

From: "Phil Neumiller" <[email-masked]>
Date: Fri, 13 Apr 2001 06:27:06 -0500

Hi Kulwinder,

BTW your direct Email in your from address is bouncing again so you
may want to check it.

----- Original Message -----
From: "Kulwinder Atwal" <[email-masked]>

> http://news.cnet.com/news/0-1005-200-5578112.html

I think you may not be giving the "real" Internet enough credit Kulwinder
and since I strangely find myself defending it these days I will try and
explain why.  We need to face up to the fact that "real" global Internet
is here now and it has proven itself to be remarkably robust and scalable.
It has also brought a lot of wealth to a lot of companies (especially Cisco :-)).

The term "peer-to-peer" is pure unaldulterated marketing hype!
The global Internet has been peer-to-peer from day 0.  It was founded
on the end-to-end principle, i.e. my IP address speaks to your IP address.
What we decide to put on top of that for window dressing is just fluff (which
may enclude military grade privacy encryption between you and your
co-horts in your version of the world).  Nobody is  stopping anybody from
doing this now, except the big carriers while caving in to world governments
that are attempting tax the spectrum and spy on their people.

As far as the database portion goes, I would like you take a look at
some work going on in Randy Katz's group at Berkley.  They have
something called OceanStore that is incredibly cool.  In this model
your secure data follows you around as you are mobile and sloshes
around in something analogous to a service provider SANs (storage
area network).  You only need your privacy key and a secure pipe
to carry your entire digital library around wherever you go.  Here is
the URL http://oceanstore.cs.berkeley.edu/ .

> are physical embodiments.

OK, and this is why, I have ranted and raved for years about a standardized
triggering mechanism between layers.  Some people like to call these things
"shims".  Back in the olden days of structured analysis we called them
SAPs and SPPs, i.e. service access points and service provision points.
Real time UML has actually adopted this model by bringing in Selic's ROOM
actors (which has SAPs and SPPs), but that is besides the point.  I, like you
I believe, would rather see a hard core protocol definition of the trigger rather
than a design abstraction for it, and hopefully the sub-IP area can get interested
in this.

> For routing protocols to be based on timers in a mobile environment has no

Yes, and you would argue that MIP does just that right?  Of course MANET
protocols typically don't and they will replace MIP soon anyway!  Fixed nodes
have used distance vector based algorithms for many moons to reach other just
fine and soon the planet will be covered with mobile routers doing somithing
very anologous to this.  Who needs timers and/or mobile IP in this coming world
I might ask?  In light of this, the home agent is silly because it is essentially burning
up an IP address to use as key value into a location database.

> Cellular Usage Model: Mobile Phone to Cell Tower.

Well, um, ah, when I was at Motorola, we did expand this model in a few
interesting way, Irridium comes to mind first but there were many other
models.  Please recall that the Internet was originally developed on a packet
radio network!

> seconds, per hour, or per millisecond?  What about Context Transfer?

Yes we have your point, event driven systems are better in many ways,
but I think they are only reliable if redundancy is added and many times
timers are adding that redundancy (in the time domain) when the event
triggers fail (in the frequency domain).

> Becuase it is impossible to predict the Usage Model.

If you study MANET algorithms Kulwinder you will see that this is  exactly
how they work (at least in the routing sense).

> We need enable all current and future Usage Models.

A bit altruistic, but I'll try to help, I like generalized solutions!

> The Mobile Real-Time Peer-To-Peer Globally Distributed Database.

Could very well be a good MANET algorithm with something like
OceanStore IMHO.

> -Kulwinder.

Best regards,

Phil

---

From: "Charles E. Perkins" <[email-masked]>
Date: Fri, 13 Apr 2001 08:59:19 -0700

Hello Phil,

I keep trying to stay out of the discussion, but haven't
the strength to withstand...

>> For routing protocols to be based on timers in a mobile environment has no

Routing protocols depend on timing in many ways.  I believe they will
continue to do so until further research is done towards omniscience.
The best result will be to minimize dependence on timers.  Getting
rid of them entirely, without replacement by mechanisms that are at
least as good, is poor engineering.  Don't you like screensavers and
alarm clocks?

> protocols typically don't and they will replace MIP soon anyway!

Even the most ardent supporter of a MANET cannot claim that it will
scale to the size of the Internet.  Right now, as far as I know, nobody
has even tried 20,000 nodes under any MANET algorithm.  Plus, it could
be that there IS NOT any natural way to do aggregation, and I just don't
think we can make a completely flat addressing model work for billions
of network nodes, even with on-demand routing and superlatively clever
engineering.

MANET so far relies on flooding control packets at least every once in
a while for route discovery or for route maintenance.  You just can't
do this in the global Internet.  Plus, a lot of MANET plus a lot of
Internet will lead to a lot of multi-path routing possibilities, with
difficult decisions about which path to take.  That just makes things
"worse", from the point of view of making MANET work.

How about this for a "better" model of the future:

- Mobile IP to support hierarchical addressing for nodes (no longer
  any need to distinguish "mobile nodes" from other nodes, since they're
  practically all mobile)
- Home agents as directory servers for routing information for mobile
  nodes
- Manets for community and local connectivity.
- Seamoby for temporary, local connectivity management while ...
- Regional Registration diffuses any necessary routing updates.

It could work...

And it points out the opportunity for improvement if someone wishes
to engineer a way for marrying bits of [seamoby-context] to manet...

>                                                                 Fixed nodes
> I might ask?  In light of this, the home agent is silly because it is essentially
> burning up an IP address to use as key value into a location database.

Since I'm in the IPv6 camp, this doesn't seem to be to be so unthinkably
horrible.  Even with IPv4, we do have a few addresses left for use.

Regards,
Charlie P.